package com.geetest.sense.servlets;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.HashMap;
import java.util.Map.Entry;

/**
 *  demo http tools,  provide md5 and post method
 */
public class Tools {
	
	public Tools() {
		super();
	}
	
	   public static String getMD5(String info) {
	        try {
	            //获取 MessageDigest 对象，参数为 MD5 字符串，表示这是一个 MD5 算法（其他还有 SHA1 算法等）：
	            MessageDigest md5 = MessageDigest.getInstance("MD5");
	            //update(byte[])方法，输入原数据
	            //类似StringBuilder对象的append()方法，追加模式，属于一个累计更改的过程
	            md5.update(info.getBytes("UTF-8"));
	            //digest()被调用后,MessageDigest对象就被重置，即不能连续再次调用该方法计算原数据的MD5值。可以手动调用reset()方法重置输入源。
	            //digest()返回值16位长度的哈希值，由byte[]承接
	            byte[] md5Array = md5.digest();
	            //byte[]通常我们会转化为十六进制的32位长度的字符串来使用,本文会介绍三种常用的转换方法
	            return bytesToHex1(md5Array);
	        } catch (NoSuchAlgorithmException e) {
	            return "";
	        } catch (UnsupportedEncodingException e) {
	            return "";
	        }
	    }

	    private static String bytesToHex1(byte[] md5Array) {
	        StringBuilder strBuilder = new StringBuilder();
	        for (int i = 0; i < md5Array.length; i++) {
	            int temp = 0xff & md5Array[i];//TODO:此处为什么添加 0xff & ？
	            String hexString = Integer.toHexString(temp);
	            if (hexString.length() == 1) {//如果是十六进制的0f，默认只显示f，此时要补上0
	                strBuilder.append("0").append(hexString);
	            } else {
	                strBuilder.append(hexString);
	            }
	        }
	        return strBuilder.toString();
	    }

//	public static String getMD5(String str) throws Exception {
//	    try {
//	        MessageDigest md = MessageDigest.getInstance("MD5");
//	        // 计算md5函数
//	        md.update(str.getBytes());
//	        // digest()最后确定返回md5 hash值，返回值为8为字符串。因为md5 hash值是16位的hex值，实际上就是8位的字符
//	        // BigInteger函数则将8位的字符串转换成16位hex值，用字符串来表示；得到字符串形式的hash值
//	        return new BigInteger(1, md.digest()).toString(16);
//	    } catch (Exception e) {
//	        throw new Exception("MD5 hash error!");
//	    }
//	}

	public static String  map2String(HashMap<String, String>  params) throws Exception{
		StringBuilder sb = new StringBuilder();
		
		for (Entry<String, String> entry : params.entrySet()) {  
			String ss = entry.getKey() + "=" + URLEncoder.encode(entry.getValue(), "UTF-8") + "&";
			sb.append(ss);
		} 
		String paramStr = sb.substring(0, sb.length() - 1);
		return paramStr;
}
	
	// HTTP POST request
	public static String sendPost(String requestUrl, String parameters) throws Exception {
		URL obj = new URL(requestUrl);
		HttpURLConnection con = (HttpURLConnection) obj.openConnection();
		con.setConnectTimeout(1000);
		con.setRequestMethod("POST");
//		con.setRequestProperty("User-Agent", USER_AGENT);
//		con.setRequestProperty("Accept-Language", "en-US,en;q=0.5");
		con.setDoOutput(true);
		DataOutputStream wr = new DataOutputStream(con.getOutputStream());
		byte b[] = parameters.getBytes("UTF8");
		wr.write(b, 0, b.length);
		wr.flush();
		wr.close();

		int responseCode = con.getResponseCode();

		if(HttpURLConnection.HTTP_OK==responseCode){
			BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
			String inputLine;
			StringBuffer response = new StringBuffer();
	
			while ((inputLine = in.readLine()) != null) {
				response.append(inputLine);
			}
			in.close();
			return response.toString();
		}else{
			return "";
		}
	}
	
}
